number FindMaxRange112(image in,number &left,number &right,number fract)
{
//find energy channels region [left,right] 
//covering intensity [fract*maxInt,maxInt]
//return also the max channel
	
number width = in.ImageGetDimensionSize(0)
number dummy,Xmax
number maxValue = max(in,Xmax,dummy)

//find left channel
image mask = imageclone(in)
mask = tert(in >= maxValue*fract,1,0)	//1: Int >= fraction of max
max(mask,left,dummy)	//approach highIntensity region from left
left --
if(left<0) left=0
//mask.showimage()

//find right channel
FlipHorizontal(mask)	//flip image
max(mask,right,dummy)	//approach highIntensity region from right
right = width - right	//flip channel
right ++
if(right>width) right =width
//result("\nleft "+left+" right "+right)

return Xmax
}

number QuadraticRegression112(number &A, number &B,number &C,image X,image Y)
{
//interpolate data image as quadratic function and returns its minimum (may be out of range)

number N = X.ImageGetDimensionSize(0)

number sumx = sum(X)
number sumx2 = sum(X**2)
number sumY = sum(Y)
number sumxy = sum(X*Y)
number sumx2y = sum(X**2*Y)
number sumx3= sum(X**3)
number sumx4= sum(X**4)

number sXX = sumx2 - (sumx**2)/N		
number sXY = sumXY - (sumX*sumY)/N		
number sXX2 = sumX3 - (sumX*sumX2)/N	
number sX2Y = sumX2Y- (sumX2*sumY)/N	
number sX2X2 = sumX4-(sumX2**2)/N		

number znam = sXX*sX2X2-sXX2**2			
A = (sX2Y*sXX-sXY*sXX2)/znam		
B = (sXY*sX2X2-sX2Y*sXX2)/znam	
C = sumY/N - b*sumX/N-a*sumX2/N

number minX = -B/2/A
return minX
}

number FindGaussianCenter112(image in,number &A,number &FWHM,number X1,number X2)
{
//Use Quadratic regression
image X:= realimage("X",4,X2-X1+1,1)
X = icol

image Y:= realimage("Y",4,X2-X1+1,1)
Y = log(in[0,X1,1,X2+1])

number C1,C2,C3
number Xmax = QuadraticRegression112(C1,C2,C3,X,Y)
//result("\nmax "+Xmax+ " A "+A+" B "+B+" C "+C)
FWHM = 2*sqrt(-0.693147/C1)
A = exp(C3-C1*Xmax**2)
Xmax += X1

return Xmax
}

number FindZLPosition112(image in,number &Intensity,number fine,number fract)
{
//find channels of maxiumum
//fine =0 :plain maximum finding
//fine =1 :fitting ZLP to Gaussian
//return also the max intensity

number ZLPos 
if(fine)
	{ 
	//rough evaluation, return also the range for further fine treatment
	number left,right
	ZLPos=FindMaxRange112(in,left,right,fract)

	//fine evaluation by fitting to Gaussian, return also Gaussian amplitude and width 
	number A,FWHM
	if(fine) ZLPos =FindGaussianCenter112(in,A,FWHM,left,right)
	Intensity =A
	}
else
	{
	number maxValue,dummy
	Intensity =max(in,ZLPos,dummy)
	}

return ZLPos
}

//this function is needed for life calibration of windows positions
number  SetFeatureInImage112(string message,string buttonName)
	{	//can be used in background thread only !!!
	number sem = NewSemaphore()
	ModelessDialog(message,buttonName,sem)
	try GrabSemaphore(sem)
	catch return 0
	return 1
	}
	