/******************************************************************
Interface for microscope specific commands (currently for FEI microscopes)
******************************************************************/
image AcquireUnprocessed112(number exposure,number binning,number top,number left,number bottom,number right)
{
return SSCUnprocessedBinnedAcquire(exposure/1000,binning,top,left,bottom,right)
}

image AcquireCorrected112(number exposure,number binning,number top,number left,number bottom,number right)
{
return SSCGainNormalizedBinnedAcquire(exposure/1000,binning,top,left,bottom,right)
}

image AcquireDarkReference112(number exposure,number binning,number top,number left,number bottom,number right)
{
return SSCGetDarkReference(exposure/1000,binning,top,left,bottom,right)
}

image GetGainReference112(number binning,number top,number left,number bottom,number right)
{
image GainReferenceFull = SSCGetGainReference(binning)
image GainReference=GainReferenceFull[top,left,bottom,right]
	
return GainReference
}

void EnableEnergyShift112()
{
IFCSetDriftTubeOn(1)
}

void SetEnergyShift112(number EnergyShift)
{
IFCSetDriftTubeVoltage(EnergyShift)
}

number GetEnergyShift112()
{
return IFCGetDriftTubeVoltage()
}

number GetYShiftValue112()
{
return IFCGetLensValue("D5Y")
}

void SetYShiftValue112(number Value)
{
IFCSetLensValue("D5Y", Value)
}
