
	
/******************************************************************
Cumulative EELS
******************************************************************/	
class CumulativeEELS112 :UIFrame112
{
number mode	//1 -low-loss	2 - core-loss	3 - combined mode
number posBinning	//binning when positioning ZLP on camera (binning 1 is too slow)
number dispersion	//energy dispersion
number exposureL,exposureH	//exposure for low-loss and core-loss acquisitions
number hardBinning //acquisition binning
number DriftTubeL,DriftTubeH	//electroscatic drift tube for low-loss and core-loss acquisitions
number runs		//maximal number of accumulated acquisitions
number darks	//number of dark currents to average

number left,right,top,bottom	//coordinates of acquisition window
number width,height				//width and height of acquisition window

number RandomChannelMax		//number of channels for spreading spectrum to average gain 
number shiftWindow		//realtive position of the shifted window (1 - up from the norml one, -1 down from the normal one)
number NormalValueY, shiftedValueY	//lens current to place ZLP either in normal or at shifted acquisition window
number ReferenceChannel		//wher ZeroLossPeak should be approximatelly located if no DriftTube applied
number sumOption	//1 - sum to 1D specgtrum, 2 -sum to 2D spectrum
number fine		//when 1 : fitting ZLP to gaussian is performed
number Frac		//fitting parameter

number cubeID,cube2ID,refID,ref2ID //IDs of images to find them out

number WaitingID	//needed to close waiting icon

//standard names for these parameters
string modeName
string runsName,darksName
string dispersionName
string PosBinningName

string ExposureLName,ExposureHName
string DriftTubeLName,DriftTubeHName
string leftName,topName,widthName,heightName
string RandomChannelMaxName
string shiftWindowName,shiftValueName
string HardBinningNAme
string ReferenceChannelName
string sumOptionName
string RandomShiftTrackName
string FinalNumberAcquisitionsName
string FineName


TagGroup CreateDialog(object self)
	{
	TagGroup DialogHead =DLGCreateDialog("").DLGTableLayout(7,1,0).DLGAnchor("West")	

	DialogHead.DLGAddElement(DLGCreatePushButton("position ZLP", "Calibrate").DLGIdentifier("CalibrateButton").DLGAnchor("East"))		
	DialogHead.DLGAddElement(DLGcreateLabel("shift Y:").DLGAnchor("East"))		
	DialogHead.DLGAddElement(DLGCreateRealField(shiftedValueY,5,2).DLGIdentifier(shiftValueName).DLGAnchor("West"))
	DialogHead.DLGAddElement(DLGcreateLabel("                "))
	DialogHead.DLGAddElement(DLGcreateLabel("                "))	
		number Bcgrd =210
		number size =20	
	DialogHead.DLGAddElement(self.settingsButton(Size,Bcgrd,"Settings").DLGAnchor("East"))
	
	
	TagGroup DialogMain =DLGCreateDialog("").DLGTableLayout(5,4,0).DLGAnchor("West")
	
	DialogMain.DLGAddElement(DLGcreateLabel("mode"))
			TagGroup PopUpItem
			TagGroup PopUp = DLGCreatePopup(PopUpItem,0)
			PopUpItem.DLGAddPopupItemEntry("low-loss")
			PopUpItem.DLGAddPopupItemEntry("core-loss")
			PopUpItem.DLGAddPopupItemEntry("combined")
			PopUp =Popup.DLGIdentifier(modeName)
	DialogMain.DLGAddElement(PopUp)
	DialogMain.DLGAddElement(DLGcreateLabel("runs").DLGAnchor("East"))	
	DialogMain.DLGAddElement(DLGCreateIntegerField(100,4).DLGIdentifier(runsName).DLGAnchor("West"))
	DialogMain.DLGAddElement(DLGCreatePushButton(" START ", "Start").DLGIdentifier("StartButton").DLGAnchor("East"))

	DialogMain.DLGAddElement(DLGCreateRealField(0.2,7,4).DLGIdentifier(dispersionName).DLGAnchor("East"))
	DialogMain.DLGAddElement(DLGcreateLabel("dispersion").DLGAnchor("West"))	
	DialogMain.DLGAddElement(DLGcreateLabel("times").DLGAnchor("East"))	
	DialogMain.DLGAddElement(DLGCreateIntegerField(10,4).DLGIdentifier(darksName).DLGAnchor("West"))
	DialogMain.DLGAddElement(DLGCreatePushButton("dark ref", "DarkReference").DLGIdentifier("DarkButton").DLGAnchor("East"))

	DialogMain.DLGAddElement(DLGcreateLabel("low-loss:"))
	DialogMain.DLGAddElement(DLGcreateLabel("Drift Tube (eV)"))	
	DialogMain.DLGAddElement(DLGCreateRealField(0,7,2).DLGIdentifier(driftTubeLName).DLGAnchor("West"))
	DialogMain.DLGAddElement(DLGcreateLabel("exp (ms)"))	
	DialogMain.DLGAddElement(DLGCreateIntegerField(40,9).DLGIdentifier(exposureLName).DLGAnchor("West"))

	DialogMain.DLGAddElement(DLGcreateLabel("high-loss:"))
	DialogMain.DLGAddElement(DLGcreateLabel("Drift Tube (eV)"))	
	DialogMain.DLGAddElement(DLGCreateRealField(0,7,2).DLGIdentifier(driftTubeHName).DLGAnchor("West"))
	DialogMain.DLGAddElement(DLGcreateLabel("exp (ms)"))	
	DialogMain.DLGAddElement(DLGCreateIntegerField(40,9).DLGIdentifier(exposureHName).DLGAnchor("West"))	
	
	
	TagGroup DialogSumm =DLGCreateDialog("").DLGTableLayout(5,1,0).DLGAnchor("West")		

	DialogSumm.DLGAddElement(DLGCreatePushButton("delete slice:", "DeleteSlice").DLGAnchor("East"))
	DialogSumm.DLGAddElement(DLGCreateIntegerField(0,4).DLGIdentifier("deletedSlice").DLGAnchor("West"))
	DialogSumm.DLGAddElement(DLGcreateLabel("                      "))
			TagGroup SummItem
			TagGroup SummPopUp = DLGCreatePopup(SummItem,sumOption)
			SummItem.DLGAddPopupItemEntry("1D")
			SummItem.DLGAddPopupItemEntry("2D")
			SummPopUp =SummPopUp.DLGIdentifier(sumOptionName)
	DialogSumm.DLGAddElement(SummPopUp)			
	DialogSumm.DLGAddElement(DLGCreatePushButton("sum up", "Summation").DLGIdentifier("SumButton").DLGAnchor("East"))
	
	
	TagGroup Dialog =DLGCreateDialog("")

	Dialog.DLGAddElement(DialogHead)
	Dialog.DLGAddElement(DialogMain)
	Dialog.DLGAddElement(DLGcreateLabel("------------------ post acquisition summation ------------------"))
	Dialog.DLGAddElement(DialogSumm)
	
	return Dialog
	}

void init(object self,string Package, string HeadName)
	{
	//names to store parameters
	topName = "top"
	leftName = "left"
	widthName = "width"
	heightName ="height"
	dispersionName ="dispersion"
	modeName ="mode"
	PosBinningName ="positionBinning"	
	runsName ="runs"
	darksName ="darks"
	ExposureLName ="exposureLow"
	ExposureHName ="exposureHigh"
	DriftTubeLName ="driftTubeLow"
	DriftTubeHName ="driftTubeHigh"
	randomChannelMaxName ="smearChannels"
	shiftWindowName ="shiftWindow"
	shiftValueName ="shiftCurrent"	
	hardBinningName ="hardbinning"
	ReferenceChannelName ="referenceChannel"
	sumOptionName = "sum option"	
	RandomShiftTrackName ="Random shift track"
	FinalNumberAcquisitionsName ="final number acquisitions"
	FineName ="ZLP fitting"

	//initialize UIFrame112
	self.initUIFrame112(self.CreateDialog(),Package,HeadName)

	//load displayed parameters
	runs =self.LoadNumber112(10,runsName)
	darks =self.LoadNumber112(2,darksName)	
	dispersion =self.LoadNumber112(0.2,dispersionName)
	mode =self.LoadNumber112(1,modeName)
	exposureL =self.LoadNumber112(50,exposureLName)
	exposureH =self.LoadNumber112(1000,exposureHName)
	driftTubeL =self.LoadNumber112(0,driftTubeLName)	
	driftTubeH =self.LoadNumber112(300,driftTubeHName)
	shiftedValueY =self.LoadNumber112(40,shiftValueName)
	sumOption =self.LoadNumber112(1,sumOptionName)
result("\nshiftedValueY "+shiftedValueY)
	
try{	//set dislayed parameters
	self.LookUpElement(runsName).DLGValue(runs)		
	self.LookUpElement(runsName).DLGValue(runs)
	self.LookUpElement(darksName).DLGValue(darks)
	self.LookUpElement(dispersionName).DLGValue(dispersion)
	self.LookUpElement(modeName).DLGValue(mode)
	self.LookUpElement(exposureLName).DLGValue(exposureL)
	self.LookUpElement(exposureHName).DLGValue(exposureH)	
	self.LookUpElement(driftTubeLName).DLGValue(driftTubeL)
	self.LookUpElement(driftTubeHName).DLGValue(driftTubeH)
	self.LookUpElement(sumOptionName).DLGValue(sumOption)	
	self.LookUpElement(shiftValueName).DLGValue(shiftedValueY)	
	}
catch{break;}

	//set unvisible settings parameters	
	top =self.LoadNumber112(896,topName)
	left =self.LoadNumber112(0,leftName)
	width =self.LoadNumber112(2048,widthName)
	height =self.LoadNumber112(256,heightName)
	randomChannelMax =self.LoadNumber112(100,RandomChannelMaxName)
	ReferenceChannel =self.LoadNumber112(200,ReferenceChannelName)
	shiftWindow =self.LoadNumber112(1,ShiftWindowName)
	posBinning =self.LoadNumber112(1,posBinningName)	
	fine =self.LoadNumber112(0,fineName)
	
	right =left +width
	bottom =top +height
	
	//hidden parameters
	try{
	NormalValueY =GetYShiftValue112() 	
		}
	catch{break;}
	
	hardBinning =self.LoadNumber112(1,hardBinningName)		
	Frac =0.3	//hardcoded parameter

result("\ntop "+top+" left "+left+" bottom "+bottom+" right "+right +" width "+width+" height "+height)	
	}

void Settings(object self)
	{	
	number NumberLines = 9		//number of adjusted parameters
	
	TagGroup topT = DLGCreateIntegerField(top,6)
	TagGroup leftT = DLGCreateIntegerField(left,6)
	TagGroup widthT = DLGCreateIntegerField(width,6)
	TagGroup heightT = DLGCreateIntegerField(height,6)
	TagGroup shiftWindowT = DLGCreateRealField(shiftWindow,6,4)
	TagGroup posBinningT = DLGCreateIntegerField(posBinning,2)		
	TagGroup RandomChannelMaxT = DLGCreateIntegerField(RandomChannelMax,4)
	TagGroup ReferenceChannelT = DLGCreateIntegerField(ReferenceChannel,4)	
	TagGroup FineFitT = DLGCreateCheckBox("gauss",fine)
	
	//Compose DLG tags
	TagGroup SettingList = DLGCreateBox("Settings").DLGTableLayout(1,NumberLines,1)
	
	//SettingsLine is UIFrame112 
	SettingList.DLGaddElement(self.SettingsLine(topName,topT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(leftName,leftT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(widthName,widthT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(heightName,heightT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(shiftWindowName,shiftWindowT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(posBinningName,posBinningT).DLGAnchor("East"))	
	SettingList.DLGaddElement(self.SettingsLine(RandomChannelMaxName,RandomChannelMaxT).DLGAnchor("East"))
	SettingList.DLGaddElement(self.SettingsLine(ReferenceChannelName,ReferenceChannelT).DLGAnchor("East"))	
	SettingList.DLGaddElement(self.SettingsLine(FineName,FineFitT).DLGAnchor("East"))
		
	object SettingsFrame = Alloc(UIframe).init(SettingList)
		if(SettingsFrame.Pose())
		{
		top =self.SettingNumberParameter(topT,topName) 
		left =self.SettingNumberParameter(leftT,leftName) 
		width =self.SettingNumberParameter(widthT,topName) 
		height =self.SettingNumberParameter(heightT,topName) 	

		right =left +width
		bottom =top +height
	
		RandomChannelMax =self.SettingNumberParameter(RandomChannelMaxT,RandomChannelMaxName) 
		ReferenceChannel =self.SettingNumberParameter(ReferenceChannelT,ReferenceChannelName) 
		shiftWindow =self.SettingNumberParameter(shiftWindowT,shiftWindowName) 
		posBinning =self.SettingNumberParameter(posBinningT,posBinningName)		
		fine =self.SettingNumberParameter(FineFitT,FineName) 	
		}
	}
	
//store all parameters when UIFrame112 is closed
number AboutToCloseUIFrame112( object self, number verify )
	{	
	shiftedValueY =self.LookUpElement(shiftValueName).DLGGetValue()
	runs =self.LookUpElement(runsName).DLGGetValue()
	darks =self.LookUpElement(darksName).DLGGetValue()
	dispersion =self.LookUpElement(dispersionName).DLGGetValue()
	mode =self.LookUpElement(modeName).DLGGetValue()
	exposureL =self.LookUpElement(exposureLName).DLGGetValue()
	exposureH =self.LookUpElement(exposureHName).DLGGetValue()
	driftTubeL =self.LookUpElement(driftTubeLName).DLGGetValue()
	driftTubeH =self.LookUpElement(driftTubeHName).DLGGetValue()
	sumOption =self.LookUpElement(sumOptionName).DLGGetValue()	
		
	self.StoreNumber112(shiftedValueY,shiftValueName)	
	self.StoreNumber112(runs,runsName)
	self.StoreNumber112(darks,darksName)
	self.StoreNumber112(dispersion,dispersionName)
	self.StoreNumber112(mode,modeName)
	self.StoreNumber112(posBinning,posBinningName)	
	self.StoreNumber112(exposureL,exposureLName)
	self.StoreNumber112(exposureH,exposureHName)
	self.StoreNumber112(driftTubeL,driftTubeLName)
	self.StoreNumber112(driftTubeH,driftTubeHName)
	self.StoreNumber112(hardBinning,hardBinningName)
	self.StoreNumber112(top,topName)
	self.StoreNumber112(left,leftName)
	self.StoreNumber112(width,widthName)
	self.StoreNumber112(height,heightName)	
	self.StoreNumber112(sumOption,sumOptionName)
		
	return 1
	}
	
	
image TransformToSpectrum(object self, image spec2D)//transfor 2D EELS(Y-E axis) into 1D spectrum (E axis only)
	{
	number width =spec2D.ImageGetDimensionSize(0)
	image Spec := realimage("spectrum", 4, width, 1)

	Spec[icol,0]+= Spec2D

	return spec
	}

image AlignImage(object self, image raw, number offset,number maxOffset)
	{
	//pixel precision alignment
	number width,height
	raw.getSize(width,height)
	
	if(offset<0) offset =0	//treat only positive shifts
	number rightBorder = width -maxOffset +offset

	image aligned =raw[0,offset,height,rightBorder]
	
	return aligned
	}

void EndCumulativeAcquisitions(object self)
	{
	SetEnergyShift112(0)
	if(Mode ==3) SetYShiftValue112(NormalValueY)

	self.EndThread("StartButton",WaitingID)	
	}

void ReadParameters(object self)
	{
	mode =self.LookUpElement(modeName).DLGgetValue()
	dispersion =self.LookUpElement(dispersionName).DLGgetValue()
result("\nmode "+mode+" dispersion "+dispersion +"eV/ch")
	driftTubeL =self.LookUpElement(DriftTubeLName).DLGgetValue() 
	driftTubeH =self.LookUpElement(DriftTubeHName).DLGgetValue() 
result("\ndriftTube low "+driftTubeL+" driftTube core "+driftTubeH)	
	ExposureL=self.LookUpElement(ExposureLName).DLGgetValue() 
	ExposureH=self.LookUpElement(ExposureHName).DLGgetValue() 
result("\nexposire low "+exposureL+ " exposure core "+exposureH)
	runs=self.LookUpElement(runsName).DLGgetValue() 
	darks=self.LookUpElement(darksName).DLGgetValue() 
result("\nruns "+runs+" darks "+darks)	
	}
			
void RunCumulativeAcquisitions(object self)
	{	
result("\nrunning cumulative EELS")	
	self.ReadParameters()
	
	number exposure
	if(Mode==1) exposure =exposureL
	if(Mode>1)  exposure =exposureH

	number driftTube
	if(Mode==1) driftTube =driftTubeL
	if(Mode>1)  driftTube =driftTubeH	//main energy region
result("\ndriftTube "+driftTube+" exposure "+exposure)

	//declare images
	image cube :=realimage("cumulative cube",4,width,height,runs)	
	image specCum :=realimage("live spectrum",4,width -RandomChannelMax,1)
specCum.showimage()
		//this is for dualEELS shifted window acquisitions
	image cube2,specCum2	
	number topShifted
	if(mode==3) 
		{
		topShifted = top -shiftWindow*height
	
		cube2:=realimage("cumulative cube low-loss",4,width,height,runs)
		specCum2 :=realimage("live spectrum low-loss",4,width -RandomChannelMax,1)
specCum2.showimage()		
		}
	image RandomDriftTrack := integerImage("RandomDriftTrack",2,0,runs,1)
	
		//this is for rough image correction: default dark current, no gain correction
		//result("\ntop"+top)
	image darkref2D =AcquireDarkReference112(exposure,hardBinning,top,left,top+height,left+width)
	image darkref2D2
	if(mode==3) darkref2D2 =AcquireDarkReference112(exposureL,hardBinning,topShifted,left,topShifted+height,left+width)
	
	
	number ZLPos
	number i
try{	
	EnableEnergyShift112()
	
	if(mode<=2)SetEnergyShift112(driftTube)
	
	for(i=0;i<runs;i++)
		{
result("\n" + i)

		if(Mode ==3) SetYShiftValue112(NormalValueY)
	
		//apply random DriftTube
		number DTrandom,RandomCh
		if(i>0)	//(first acquisition is without random DriftTube)
			{
			DTrandom = Round(RandomChannelMax*UniformRandom()*Dispersion*10)/10	//precision 0.1V
			RandomCh = Round(DTrandom/Dispersion)
			RandomDriftTrack.setPixel(i,0,RandomCh)
result(" DTrandom=" +DTrandom+"eV ("+RandomCh+"ch) ") 		
			}
		SetEnergyShift112(driftTube-DTrandom)

		//acquire image
		image spec2D =AcquireUnprocessed112(exposure,hardBinning,top,left,bottom,right)
		image spec =self.TransformToSpectrum(spec2D-darkref2D)
		image spec2,spec2D2
		if(mode==3)
			{		
			SetEnergyShift112(driftTubeL-DTrandom)
			SetYShiftValue112(NormalValueY +shiftedValueY)

			spec2D2 =AcquireUnprocessed112(exposureL,hardBinning,topShifted,left,topShifted+height,right)
			cube2[0,0,i,width,height,i+1] =spec2D2

			spec2 =self.TransformToSpectrum(spec2D2-darkref2D2)	
			}
		
		//find reference point for further alignment
		number Xmax,Int
		if(mode==1) Xmax  =FindZLPosition112(spec,Int,0,Frac)	//low-loss
		if(mode==2) Xmax  =ReferenceChannel +RandomCh	//core-loss
		if(mode==3) Xmax  =FindZLPosition112(spec2,Int,0,Frac)	//combined
result(" ZLP "+Xmax+" Intensity "+Int)
	
		// calibration using the first acquisition (no random shift)
		if(i==0)	
			{
			ZLPos =Xmax
			number NullChannel =Xmax -DriftTube/dispersion
			ImageSetDimensionCalibration(cube,0,NullChannel,Dispersion, "eV",1)
			ImageSetDimensionCalibration(specCum,0,NullChannel,Dispersion, "eV",1)
			
			if(mode==3)
				{
				number NullChannel =Xmax -DriftTubeL/dispersion
				
				ImageSetDimensionCalibration(cube2,0,NullChannel,Dispersion, "eV",1)				
				ImageSetDimensionCalibration(specCum2,0,NullChannel,Dispersion, "eV",1)
			
				}
			}
	

		//accumuilation of 2D and acumulation&alignment of 1D spectra
		image aligned :=self.AlignImage(spec,Xmax-ZLPos,RandomChannelMax)
		number alignedWidth =aligned.ImageGetDimensionSize(0)		
		specCum[0,0,1,alignedWidth] +=aligned
		specCum.updateimage()
		
//result(" AW "+alignedWidth)
		cube[0,0,i,width,height,i+1] =spec2D
		if(mode==3)
			{	
			image aligned2 :=self.AlignImage(spec2,Xmax-ZLPos,RandomChannelMax)		
			number alignedWidth =aligned.ImageGetDimensionSize(0)
	
			specCum2[0,0,1,alignedWidth] +=aligned2
			
			specCum2.updateimage()	
			
			cube2[0,0,i,width,height,i+1] =spec2D2		
			}
			
			
		if(SpaceDown()) if (!ContinueCancelDialog("Continue ?")) {i++;break;}
		}	
	}	
catch
	{
	break
	self.EndCumulativeAcquisitions()
	}
	
	//RandomDriftTrack.showimage()
	cube.showimage()
	if(mode ==3)cube2.showimage()
	
	TagGroup ImTags = cube.ImageGetTagGroup()
	ImTags.TagGroupSetTagAsArray("temDM:CumulativeEELS"+":Random shift",RandomDriftTrack)
	ImTags.TagGroupSetTagAsLong("temDM:CumulativeEELS"+":runs",i)
	ImTags.TagGroupSetTagAsString("temDM:CumulativeEELS"+":type","spectra stack")
	ImTags.TagGroupSetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposure)

		if(mode==3)
			{
			TagGroup ImTags2 = cube2.ImageGetTagGroup()
			ImTags2.TagGroupSetTagAsArray("temDM:CumulativeEELS"+":Random shift",RandomDriftTrack)
			ImTags2.TagGroupSetTagAsLong("temDM:CumulativeEELS"+":runs",i)
			ImTags2.TagGroupSetTagAsString("temDM:CumulativeEELS"+":type","spectra stack 2")
			ImTags2.TagGroupSetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposureL)
			}
			
	self.EndCumulativeAcquisitions()
	}

void Start( object self )
	{
	WaitingID =self.StartThreadFromDLG("RunCumulativeAcquisitions","StartButton")
	}

void MakeDarkReference(object self)
	{
result("\ncollect dark reference")	
	self.ReadParameters()
	
	number exposure
	if(Mode==1) exposure =exposureL
	if(Mode>1)  exposure =exposureH
		
	OKdialog("Blank beam !")

	string type
	if(mode==1) type ="low-loss"
	if(mode>=2) type ="core-loss"

	image DarkRef :=realimage("darkRef",4,width,height)
	image References :=realimage("references "+type,4,width,height,2)
	image DarkRef2,References2
	number topShifted,bottomShifted
		{
		DarkRef2 :=realimage("darkRef",4,width,height)
		References2 :=realimage("references low-loss shifted",4,width,height,2)
		topShifted = top -shiftWindow*height
		}	
	
	for(number i=0;i<darks;i++)
		{
		result("\ni "+i)
		DarkRef +=AcquireUnprocessed112(exposure,hardBinning,top,left,top+height,left+width)
		
		if(mode==3) 
			{
result("\nexposureL "+exposureL	)		
			DarkRef2 +=AcquireUnprocessed112(exposureL,hardBinning,topShifted,left,topShifted+height,left+width)
			}
		}
	DarkRef /=darks
	
	References[0,0,0,width,height,1] =DarkRef
	
	image GainRef =GetGainReference112(hardbinning,top,left,bottom,right)
	References[0,0,1,width,height,2] =GainRef

	References.showimage()
	
	TagGroup ImTags = References.ImageGetTagGroup()
	ImTags.TagGroupSetTagAsLong("temDM:CumulativeEELS"+":times",darks)
	ImTags.TagGroupSetTagAsString("temDM:CumulativeEELS"+":type","references")
	ImTags.TagGroupSetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposure)
	
	if(mode==3) 
		{
		DarkRef2 /=darks 
		
		References2[0,0,0,width,height,1] =DarkRef2
	
		image GainRef2 =GetGainReference112(hardbinning,topShifted,left,topShifted+height,right)
		References2[0,0,1,width,height,2] =GainRef2

		References2.showimage()
		
		TagGroup ImTags = References2.ImageGetTagGroup()
		ImTags.TagGroupSetTagAsLong("temDM:CumulativeEELS"+":times",darks)
		ImTags.TagGroupSetTagAsString("temDM:CumulativeEELS"+":type","references")
		ImTags.TagGroupSetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposureL)
		
		}
		
	self.EndThread("DarkButton",WaitingID)	
	}
	
void DarkReference(object self)
	{
	WaitingID =self.StartThreadFromDLG("MakeDarkReference","DarkButton")	
	}


void StopCalibrate(object self,object ContiniousView)
	{
	ContiniousView.Stop();
	self.EndThread("CalibrateButton",WaitingID);
	throw("");
	}
		
void MakeCalibrate(object self)
	{
	number widthFull,heightFull
	If(!SSCgetSize(widthFull,heightFull)) {Result("\nFAIL TO GET CCD SIZE !!!");exit(0);}
result("\nCamera "+widthFull+"x"+heightFull)	

	OKdialog("Ensure that the filter camera is chosen !!")
	
	object ContiniousView = alloc(ContinuousPositioning112)	 
result("\nexposure "+exposureL)	
	ContiniousView.init(self.ScriptObjectGetID(),ShiftValueName,exposureL,Posbinning,widthFull,heightFull)
	
	ContiniousView.Normal_Ymode()
	ContiniousView.DrawWindow(top,left,bottom,right,"red")
	
	if(!SetFeatureInImage112("Position ZLP using microscope/FilterControl buttons", "continue" )) self.StopCalibrate(ContiniousView)	

	NormalValueY =ContiniousView.StoreNormalY()
	
	ContiniousView.shifted_Ymode(ShiftedValueY)
	number delta =shiftWindow*height
	ContiniousView.DrawWindow(top-delta,left,bottom-delta,right,"green")
	
	if(!SetFeatureInImage112("position ZLP by changing shift Y \nnumber (press ENTER)", "finish" )) self.StopCalibrate(ContiniousView)
	
	self.StopCalibrate(ContiniousView)	
	}
	
void Calibrate(object self)
	{
result("\ncalibrate shift Y")
	
	WaitingID =self.StartThreadFromDLG("MakeCalibrate","CalibrateButton")			
	}


void DeleteSlice(object self)
	{
	image cube:=getFrontImage()
	number width,height,runs	//here papameters are local
	cube.get3Dsize(width,height,runs)

	TagGroup ImTags = cube.ImageGetTagGroup()
	image deleted :=integerimage("deleted",1,0,runs,1)
	ImTags.TagGroupGetTagAsArray("temDM:CumulativeEELS"+":deleted",deleted)	
	
	number sliceNo =self.LookUpElement("deletedSlice").DLGgetValue()
	if(sliceNo<runs)
		{
		result("\n"+sliceNo+" slice deleted")
		
		deleted.setPixel(sliceNo,0,1)
		ImTags.TagGroupSetTagAsArray("temDM:CumulativeEELS"+":deleted",deleted)	
		
		cube[0,0,SliceNo,width,height,SliceNo+1] =0
		}
	}

//check if acquisition time of image1 fits that of image2
number CheckImages(object self,image image1,image image2)
	{
	number exposure1 
	TagGroup ImTags1 = image1.ImageGetTagGroup()
	ImTags1.TagGroupGetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposure1)	
	
	number exposure2 
	TagGroup ImTags2 = image1.ImageGetTagGroup()
	ImTags2.TagGroupGetTagAsFloat("temDM:CumulativeEELS"+":exposure (ms)",exposure2)	
result("\nexposure1 "+exposure1+" exposure2 "+exposure2)	
	if(exposure1 ==exposure2) return 1
	else return 0
	}
	


image get3DReference(object self,image reference2D,number depth)
	{
	number width,height	//here papameters are local
	reference2D.getSize(width,height)
	
	image reference3D = realimage("",4,width,height,depth)
	reference3D =reference2D[icol,irow,0]
	
	return reference3D
	}
	
image ExtractShifts(object self,image cubeWithZLP,image references)
	{
	number width,height,MaxRuns	//here papameters are local
	cubeWithZLP.get3Dsize(width,height,MaxRuns)
	
	image DarkRef =References[0,0,0,width,height,1] 

	image cubeTemp =cubeWithZLP -self.get3DReference(DarkRef,MaxRuns)
//cubeTemp.showimage()	
	
	image Shifts :=integerimage("",2,1,MaxRuns,1)
	
	TagGroup ImTags= cubeWithZLP.ImageGetTagGroup()
	number runs
	ImTags.TagGroupGetTagAsLong("temDM:CumulativeEELS"+":runs",runs)
	image deleted :=integerimage("deleted",1,0,Maxruns,1)
	ImTags.TagGroupGetTagAsArray("temDM:CumulativeEELS"+":deleted",deleted)	
			
	
	for(number i=0;i<runs;i++)
		{		
		if(deleted.getPixel(i,0)!=1)
			{
			image spec2D =cubeTemp[0,0,i,width,height,i+1]

			image spec =self.TransformToSpectrum(spec2D)

			number Int
			
			number Xmax =FindZLPosition112(spec,Int,fine,Frac)

			Shifts.setPixel(i,0,Xmax)
			}
//Shifts.showimage()

		number minZLP = min(Shifts)
		Shifts -=minZLP	
		}
			
	return shifts	
	}


	//substract dark reference, correct for gain and sum up provided that shifts are known
image AlignAndSum(object self,image cube,image references,image shifts)
	{
	image cubeTemp :=cube.imageclone()
	
	number width,height,Maxruns	//here papameters are local
	cubeTemp.get3Dsize(width,height,Maxruns)

	//check if acquisitions were terminated or some were deleted
	TagGroup ImTags = cube.ImageGetTagGroup()
	image deleted :=integerimage("deleted",1,0,Maxruns,1)
	ImTags.TagGroupGetTagAsArray("temDM:CumulativeEELS"+":deleted",deleted)	
	number runs //here is local
	ImTags.TagGroupGetTagAsLong("temDM:CumulativeEELS"+":runs",runs)	//runs number might be reduced from tag
//deleted.showimage()
	
	//extract references
	image DarkRef =References[0,0,0,width,height,1] 
	image GainRef =References[0,0,1,width,height,2]

	cubeTemp -=self.get3DReference(DarkRef,Maxruns)
	cubeTemp /=self.get3DReference(GainRef,Maxruns)
	
	number maxShift =max(shifts)
	image sumimage = realimage("",4,width -maxShift,height)
//sumimage.showimage()

	for(number i=1;i<runs;i++)
		{	
result("\n"+i)		
		if(deleted.getPixel(i,0)!=1)
			{
			image spec2D =cubeTemp[0,0,i,width,height,i+1]
			
			number shift =shifts.getPixel(i,0)
result(" shift "+shift)			
			image aligned2D :=self.AlignImage(spec2D,shift,maxShift)
			number alignedWidth =aligned2D.ImageGetDimensionSize(0)	
//aligned2D.showimage()	
			sumimage[0,0,height,alignedWidth] +=aligned2D
result(" added")	
			}
		}
		
	return sumimage
	}


	//main unit making summation
void SumUp(object self)
	{
	try{
		mode =self.LookUpElement(modeName).DLGgetValue()
			
		image cube,references
		image cube2,references2

		if(cubeID !=0) cube :=cubeID.getImagefromID(); else {OKdialog("cube not valid");exit(0);}
		if(refID !=0) references :=refID.getImagefromID(); else {OKdialog("reference not valid");exit(0);}
		number Dispersion,NullChannel,NullChannel2
		string units
		ImageGetDimensionCalibration(cube,0,NullChannel,Dispersion, units,1)

		if(mode==3)	//combined low-loss + core-loss 
			{
			if(cube2ID !=0) cube2 :=cube2ID.getImagefromID(); else {OKdialog("cube2 not valid");exit(0);}
			if(ref2ID !=0) references2 :=ref2ID.getImagefromID(); else {OKdialog("reference2 not valid");exit(0);}		
			ImageGetDimensionCalibration(cube2,0,NullChannel2,Dispersion, units,1)
			}		
		
		image sumimage,sumimage2		
		image shifts		
		
		if(mode==1)	//low-loss
			{			
			//extract shifts from variation of ZLP		
			shifts :=self.ExtractShifts(cube,references)
//shifts.showimage()

			sumimage :=self.AlignAndSum(cube,references,shifts)
			}
		
		if(mode==2)	//core-loss
			{
			//extract shifts from recorded values of random drift tube shift
			TagGroup ImTags = cube.ImageGetTagGroup()

			shifts := integerImage("RandomDriftTrack",2,0,runs,1)
			ImTags.TagGroupGetTagAsArray("temDM:CumulativeEELS"+":Random shift",shifts)
			
			sumimage :=self.AlignAndSum(cube,references,shifts)

			}
			
		if(mode==3)	//combined low-loss + core-loss
			{
			//extract shifts from variation of ZLP in low-loss region
			shifts :=self.ExtractShifts(cube2,references2)
			
			sumimage :=self.AlignAndSum(cube,references,shifts)
			sumimage2 :=self.AlignAndSum(cube2,references2,shifts)
			}
		
		sumOption =self.LookUpElement(sumOptionName).DLGgetValue()	//1 - 1D output, 2 - 2D output

		if(sumOption==2)	//2D output cumulative spectrum
			{
			sumimage.setName("summed")
			sumimage.showimage()
			ImageSetDimensionCalibration(sumimage,0,NullChannel,Dispersion,units,1)
			if(mode==3) 
				{
				sumimage2.setName("summed low-loss")
				sumimage2.showimage()
				ImageSetDimensionCalibration(sumimage2,0,NullChannel,Dispersion,units,1)
				}
			}
		else				//1D output cumulative spectrum
			{
			image Finspec :=self.TransformToSpectrum(sumimage)
			Finspec.setName("spectrum summed")
			Finspec.showimage()
			ImageSetDimensionCalibration(Finspec,0,NullChannel,Dispersion,units,1)
			
			if(mode==3) //combined low-loss + core-loss
				{
				image Finspec2 =self.TransformToSpectrum(sumimage2)
				Finspec2.setName("spectrum summed low-loss")
				Finspec2.showimage()
				ImageSetDimensionCalibration(Finspec2,0,NullChannel2,Dispersion,units,1)
				}
			}
		}
	catch {break;}	
	
	self.EndThread("SumButton",WaitingID);
	
	cubeID =0
	refID =0
	cube2ID =0
	ref2ID =0		
	}

	
	//choose images and fire summation	
void Summation(object self)
	{
	mode =self.LookUpElement(modeName).DLGgetValue()

	image cube,references
	image cube2, references2
	
	if(!GetTwoImages("choose: 0-cumulative image, 1-references",cube,references)) exit(0)
	self.CheckImages(cube,references)	//check if acquisition time of reference fit that of cube
	
	if(mode==3) 
		{
		OKdialog("Repeate selection for low-loss images")
			
		if(!GetTwoImages("choose: 0-ZLP cumulative image, 1-ZLP references",cube2,references2)) exit(0)
		self.CheckImages(cube2,references2)	//check if acquisition time of reference fit that of cube
		}
	
	//put their IDs into memory		
	cubeID =ImageGetID(cube)
	refID =ImageGetID(references)
		if(mode==3) 
		{
		cube2ID =ImageGetID(cube2)
		ref2ID =ImageGetID(references2)	
		}
	
	//fire summation	
	WaitingID =self.StartThreadFromDLG("SumUp","SumButton")	
	}

}

//lunch Cumulative EELS		 
{
//check if ExtendedFrames are loaded
if(!doesFunctionExist("LoadNumber112")) 
	{
	OKdialog("Please drop 'temDM extFrames.gt3' plugin in the plugins folder !!");
	exit(0);
	}	
	
string Package = "_temDM-Scripts:CumulativeEELS"
string HeadName = "Cumulative"
alloc(CumulativeEELS112).init(Package,HeadName);		
}
